// Libary nodig voor gerbuik Servo's
#include <Servo.h>

// Aanmaken variablen bewegingssensor en registreren op pin 2
int pirSensor = 2;
int statusSensor = 0;
bool movement;
bool spray;

// Aanmaken variablen voor vleugels servo
Servo wing1;
int pos = 0;
int flapCount = 0;

// Aanmaken variablen voor berekenen cooldown
unsigned long runTime;
unsigned long startTime;
// Timer staat op 1 minuut cooldown, na deze 1 minuut kan bewegingssensor weer meten
int cooldown = 60000;

// Aanmaken variablen voor luchtverfrisser servo
Servo servoButton;
int buttonPos = 0;
int sprayPressed = 0;

void setup()
{
  // Methode voor inputs en outputs wordt gestart
  PinMode();
  Serial.begin(9600);
  // Registreer startwaarde
  startTime = -cooldown;
  movement = false;
  spray = true;
}

void loop()
{
  // Update runTime met werkelijke tijd
  runTime = millis();
  // Methodes voor sensor en servo's
  PirSensor();
  ButtonPress();
  BeeWings();
}

void PinMode()
{
  // Registreer alle inputs en outputs
  pinMode(pirSensor, INPUT);
  wing1.attach(9);
  servoButton.attach(11);
}

void PirSensor()
{
  // Wanneer de cooldown van 1 minuut voorbij is dan
  if ((runTime - startTime) > cooldown
  {
    // Voor feedback in de console
    statusSensor = digitalRead(pirSensor);
    Serial.println(statusSensor);
    // Wanneer er beweging is waargenomen dan
    if (statusSensor == HIGH)
    {
      // Start Luchtspray & Vleugels cyclus 
      startTime = millis();
      movement = true;
      spray = true;
    }
  }
  else
  {
    // Weergeeft in de console de resterde tijd voordat de senor weer kan meten
    Serial.println((cooldown - (runTime - startTime)) / 1000);
  }
}

void BeeWings()
{
  // Wanneer er beweging is en tijd cooldown is verstrekken dan
  if (movement)
  {
    // Voer 6 keer uit
    for (flapCount = 0; flapCount <= 5; flapCount += 1)
    {
      // Vleugel omlaag bewegen
      for (pos = 2; pos <= 180; pos += 5)
      {
        wing1.write(pos);
        delay(20);
      }
      // Vleugel omhoog bewegen
      for (pos = 180; pos >= 2; pos -= 5)
      {
        wing1.write(pos);
        delay(20);
      }
      // Wanneer 6 keer de vleugels zijn bewogen dan
      if (flapCount >= 5)
      {
        // Stop vleugels
        movement = false;
        spray = true;
      }
    }
  }
}

void ButtonPress()
{
  // Wanneer er beweging is en vleugel scene is afgelopen dan
  if (movement && spray)
  {
    // Voer 1 keer uit
    for (sprayPressed = 0; sprayPressed < 1; sprayPressed += 1)
    {
      // Drukt 1 keer de lucht verfrisser in en keer terug op positie
      servoButton.write(90);
      delay(1200);
      servoButton.write(90);
      delay(1200);
      servoButton.write(120);
      delay(1200);
      servoButton.write(90);
      // Wanneer 1 keer is ingedrukt dan
      if (sprayPressed >= 2)
      {
        // Stop indrukken luchtverfrisser
        spray = false;
        return;
      }
    }
  }
}
